_UART6_Interrupt:
;UART6.c,59 :: 		void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
;UART6.c,64 :: 		if ((RXNE_USART6_SR_bit) /* || (ORE_bit) */ ) {
MOVW	R1, #lo_addr(RXNE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Interrupt0
;UART6.c,65 :: 		R_data = USART6_DR;           // Fetch a byte from receive register
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
; R_data start address is: 12 (R3)
LDR	R3, [R0, #0]
;UART6.c,66 :: 		RxQueue[RxIn++] = R_data;     // Put data byte in re-circulating buffer, increment pointer
MOVW	R2, #lo_addr(_RxIn+0)
MOVT	R2, #hi_addr(_RxIn+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RxQueue+0)
MOVT	R0, #hi_addr(_RxQueue+0)
ADDS	R0, R0, R1
STRB	R3, [R0, #0]
; R_data end address is: 12 (R3)
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART6.c,67 :: 		if (RxIn > (rxqsize-1))       // Adjust pointer if necessary
CMP	R0, #255
IT	LS
BLS	L_UART6_Interrupt1
;UART6.c,68 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
L_UART6_Interrupt1:
;UART6.c,69 :: 		}
L_UART6_Interrupt0:
;UART6.c,71 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
MOVW	R1, #lo_addr(TXE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt52
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt51
L__UART6_Interrupt50:
;UART6.c,72 :: 		T_data = XmtBuf[XmtBufPtr++]; // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_XmtBufPtr+0)
MOVT	R2, #hi_addr(_XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART6.c,73 :: 		if (T_data == NUL) {          // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART6_Interrupt5
; T_data end address is: 12 (R3)
;UART6.c,74 :: 		TXEIE_USART6_CR1_bit = 0; // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,75 :: 		} else {
IT	AL
BAL	L_UART6_Interrupt6
L_UART6_Interrupt5:
;UART6.c,76 :: 		USART6_DR = T_data;       // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART6.c,77 :: 		}
L_UART6_Interrupt6:
;UART6.c,71 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
L__UART6_Interrupt52:
L__UART6_Interrupt51:
;UART6.c,79 :: 		}
L_end_UART6_Interrupt:
BX	LR
; end of _UART6_Interrupt
_UART6_SetBaud:
;UART6.c,83 :: 		void UART6_SetBaud(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,85 :: 		GPIOCEN_bit = 1;                  // Set GPIOC clock enable bit
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(GPIOCEN_bit+0)
MOVT	R0, #hi_addr(GPIOCEN_bit+0)
STR	R2, [R0, #0]
;UART6.c,87 :: 		GPIOC_MODER |= 0x0000A000;        // Set port C MODER bits 6 and 7 to 10: alternate function mode
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #40960
MOVW	R0, #lo_addr(GPIOC_MODER+0)
MOVT	R0, #hi_addr(GPIOC_MODER+0)
STR	R1, [R0, #0]
;UART6.c,88 :: 		GPIOC_AFRL |= 0x88000000;         // Select alternate function 1000: AF8 for bits 6 and 7
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #-2013265920
MOVW	R0, #lo_addr(GPIOC_AFRL+0)
MOVT	R0, #hi_addr(GPIOC_AFRL+0)
STR	R1, [R0, #0]
;UART6.c,90 :: 		USART6EN_bit = 1;                 // Set USART6 clock enable bit
MOVW	R0, #lo_addr(USART6EN_bit+0)
MOVT	R0, #hi_addr(USART6EN_bit+0)
STR	R2, [R0, #0]
;UART6.c,91 :: 		USART6_CR1 |= 0x0000200C;         // Set UE, TE, and RE in USART6 control register 1
MOVW	R0, #lo_addr(USART6_CR1+0)
MOVT	R0, #hi_addr(USART6_CR1+0)
LDR	R1, [R0, #0]
MOVW	R0, #8204
ORRS	R1, R0
MOVW	R0, #lo_addr(USART6_CR1+0)
MOVT	R0, #hi_addr(USART6_CR1+0)
STR	R1, [R0, #0]
;UART6.c,92 :: 		USART6_BRR = 0x00001E84;          // Set baud rate register for 9600
MOVW	R1, #7812
MOVW	R0, #lo_addr(USART6_BRR+0)
MOVT	R0, #hi_addr(USART6_BRR+0)
STR	R1, [R0, #0]
;UART6.c,94 :: 		NVIC_IntEnable(IVT_INT_USART6);   // Enable interrupt vector
MOVW	R0, #87
BL	_NVIC_IntEnable+0
;UART6.c,96 :: 		}
L_end_UART6_SetBaud:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SetBaud
_UART6_StartRx:
;UART6.c,100 :: 		void UART6_StartRx(void) {
;UART6.c,101 :: 		RXNEIE_USART6_CR1_bit = 1;        // Interrupt when receive buffer is full (RXNE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,102 :: 		}
L_end_UART6_StartRx:
BX	LR
; end of _UART6_StartRx
_UART6_StartTx:
;UART6.c,106 :: 		void UART6_StartTx(void) {
;UART6.c,107 :: 		TXEIE_USART6_CR1_bit = 1;         // Interrupt when transmit buffer is empty (TXE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,108 :: 		}
L_end_UART6_StartTx:
BX	LR
; end of _UART6_StartTx
_UART6_Initialize:
;UART6.c,117 :: 		void UART6_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,118 :: 		UART6_RxQueueInit();
BL	_UART6_RxQueueInit+0
;UART6.c,119 :: 		UART6_TxQueueInit();
BL	_UART6_TxQueueInit+0
;UART6.c,121 :: 		UART6_SetBaud();
BL	_UART6_SetBaud+0
;UART6.c,122 :: 		UART6_StartRx();
BL	_UART6_StartRx+0
;UART6.c,123 :: 		}
L_end_UART6_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Initialize
_UART6_RxQueueInit:
;UART6.c,128 :: 		void UART6_RxQueueInit(void) {
;UART6.c,129 :: 		RxIn = RxOut = 0;                 // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxOut+0)
MOVT	R0, #hi_addr(_RxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART6.c,130 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,131 :: 		}
L_end_UART6_RxQueueInit:
BX	LR
; end of _UART6_RxQueueInit
_UART6_GetChar:
;UART6.c,137 :: 		char UART6_GetChar(char *rxbyte) {
; rxbyte start address is: 0 (R0)
; rxbyte end address is: 0 (R0)
; rxbyte start address is: 0 (R0)
;UART6.c,138 :: 		if (RxIn != RxOut) {              // If there is a character in the buffer
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_RxIn+0)
MOVT	R1, #hi_addr(_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART6_GetChar7
;UART6.c,139 :: 		*rxbyte = RxQueue[RxOut++];    // Extract the character and update the pointer
MOVW	R3, #lo_addr(_RxOut+0)
MOVT	R3, #hi_addr(_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_RxQueue+0)
MOVT	R1, #hi_addr(_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
; rxbyte end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART6.c,140 :: 		if (RxOut > (rxqsize-1))       // Check for wrap
CMP	R1, #255
IT	LS
BLS	L_UART6_GetChar8
;UART6.c,141 :: 		RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
STRB	R2, [R1, #0]
L_UART6_GetChar8:
;UART6.c,142 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART6_GetChar
;UART6.c,143 :: 		}else{
L_UART6_GetChar7:
;UART6.c,144 :: 		return 0;                      // No data available
MOVS	R0, #0
;UART6.c,146 :: 		}
L_end_UART6_GetChar:
BX	LR
; end of _UART6_GetChar
_UART6_Rx:
;UART6.c,150 :: 		void UART6_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,151 :: 		UART6_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART6_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART6.c,152 :: 		}
L_end_UART6_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Rx
_UART6_Rx1:
;UART6.c,157 :: 		void UART6_Rx1(void){
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,160 :: 		if (UART6_GetChar(&rxchar)) {
ADD	R0, SP, #4
BL	_UART6_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx110
;UART6.c,161 :: 		switch (rxchar) {
IT	AL
BAL	L_UART6_Rx111
;UART6.c,162 :: 		case NUL:         // Discard NUL character
L_UART6_Rx113:
;UART6.c,163 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,165 :: 		case '\r':        // Discard return character
L_UART6_Rx114:
;UART6.c,166 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,168 :: 		case '\n':
L_UART6_Rx115:
;UART6.c,169 :: 		RcvBuf[RcvBufPtr++] = rxchar;       // Put received character into buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,170 :: 		RcvBuf[RcvBufPtr] = 0;              // End marker
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART6.c,171 :: 		RcvBufPtr = 0;                      // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART6.c,172 :: 		UART6_RxFuncPtr = UART6_Rx2;        // Go to state 2
MOVW	R1, #lo_addr(_UART6_Rx2+0)
MOVT	R1, #hi_addr(_UART6_Rx2+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,173 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,175 :: 		default:
L_UART6_Rx116:
;UART6.c,176 :: 		if (RcvBufPtr < (RcvBufSize-2))     // Prevents buffer overrun
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	CS
BCS	L_UART6_Rx117
;UART6.c,177 :: 		RcvBuf[RcvBufPtr++] = rxchar;   // Put character in buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART6_Rx117:
;UART6.c,178 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,179 :: 		}
L_UART6_Rx111:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx113
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART6_Rx114
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART6_Rx115
IT	AL
BAL	L_UART6_Rx116
L_UART6_Rx112:
;UART6.c,180 :: 		}
L_UART6_Rx110:
;UART6.c,181 :: 		}
L_end_UART6_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx1
_UART6_Rx2:
;UART6.c,186 :: 		void UART6_Rx2(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,191 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART6_Rx218
;UART6.c,195 :: 		case 'a': // Diagnostic message as verification interface is working properly
L_UART6_Rx220:
;UART6.c,196 :: 		UART6_PutQueue("Command 'a' received\r\n");
MOVW	R0, #lo_addr(?lstr1_UART6+0)
MOVT	R0, #hi_addr(?lstr1_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,197 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,199 :: 		case 'b': // Display shadow register buffer
L_UART6_Rx221:
;UART6.c,200 :: 		DispShadowBuf();
BL	_DispShadowBuf+0
;UART6.c,201 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,203 :: 		case 'c':
L_UART6_Rx222:
;UART6.c,204 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,206 :: 		case 'd':
L_UART6_Rx223:
;UART6.c,207 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,209 :: 		case 'e':
L_UART6_Rx224:
;UART6.c,210 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,212 :: 		case 'f':
L_UART6_Rx225:
;UART6.c,213 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,215 :: 		case 'g':
L_UART6_Rx226:
;UART6.c,216 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,218 :: 		case 'h':
L_UART6_Rx227:
;UART6.c,219 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,221 :: 		case 'i':
L_UART6_Rx228:
;UART6.c,222 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,224 :: 		case 'j':
L_UART6_Rx229:
;UART6.c,225 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,227 :: 		case 'k':
L_UART6_Rx230:
;UART6.c,228 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,230 :: 		case 'l':
L_UART6_Rx231:
;UART6.c,231 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,233 :: 		case 'm':
L_UART6_Rx232:
;UART6.c,234 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,236 :: 		case 'n':
L_UART6_Rx233:
;UART6.c,237 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,239 :: 		case 'o':
L_UART6_Rx234:
;UART6.c,240 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,242 :: 		case 'p':
L_UART6_Rx235:
;UART6.c,243 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,245 :: 		case 'r':
L_UART6_Rx236:
;UART6.c,246 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,248 :: 		case 's':
L_UART6_Rx237:
;UART6.c,249 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,251 :: 		case 't':
L_UART6_Rx238:
;UART6.c,252 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,254 :: 		case 'u':
L_UART6_Rx239:
;UART6.c,255 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,257 :: 		case 'v':
L_UART6_Rx240:
;UART6.c,258 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,260 :: 		case 'w':
L_UART6_Rx241:
;UART6.c,261 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,263 :: 		case 'x':
L_UART6_Rx242:
;UART6.c,264 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,266 :: 		case 'y':
L_UART6_Rx243:
;UART6.c,267 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,269 :: 		case 'z':
L_UART6_Rx244:
;UART6.c,270 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,273 :: 		default:
L_UART6_Rx245:
;UART6.c,274 :: 		UART6_PutQueue("Unknown command: ");
MOVW	R0, #lo_addr(?lstr2_UART6+0)
MOVT	R0, #hi_addr(?lstr2_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,276 :: 		BufNum = GetBuffer();                // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,277 :: 		(void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_UART6+0)
MOVT	R1, #hi_addr(?lstr_3_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,278 :: 		UART6_PutQueue(BufNum);              // Send the message
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,279 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,280 :: 		}
L_UART6_Rx218:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_UART6_Rx220
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_UART6_Rx221
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_UART6_Rx222
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_UART6_Rx223
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_UART6_Rx224
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_UART6_Rx225
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_UART6_Rx226
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_UART6_Rx227
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_UART6_Rx228
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_UART6_Rx229
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_UART6_Rx230
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_UART6_Rx231
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_UART6_Rx232
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_UART6_Rx233
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_UART6_Rx234
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_UART6_Rx235
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_UART6_Rx236
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_UART6_Rx237
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_UART6_Rx238
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_UART6_Rx239
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_UART6_Rx240
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_UART6_Rx241
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_UART6_Rx242
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_UART6_Rx243
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_UART6_Rx244
IT	AL
BAL	L_UART6_Rx245
L_UART6_Rx219:
;UART6.c,281 :: 		UART6_RxFuncPtr = UART6_Rx1;               // Go back to state 1
MOVW	R1, #lo_addr(_UART6_Rx1+0)
MOVT	R1, #hi_addr(_UART6_Rx1+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,282 :: 		}
L_end_UART6_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx2
_UART6_TxQueueInit:
;UART6.c,289 :: 		void UART6_TxQueueInit(void) {
;UART6.c,290 :: 		TxIn = TxOut = 0;         // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
STRB	R1, [R0, #0]
;UART6.c,291 :: 		XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,292 :: 		}
L_end_UART6_TxQueueInit:
BX	LR
; end of _UART6_TxQueueInit
_UART6_PutQueue:
;UART6.c,297 :: 		void UART6_PutQueue(char *msg) {
; msg start address is: 0 (R0)
; msg end address is: 0 (R0)
; msg start address is: 0 (R0)
;UART6.c,298 :: 		TxQueue[TxIn++] = msg;    // Put the message pointer into FIFO
MOVW	R3, #lo_addr(_TxIn+0)
MOVT	R3, #hi_addr(_TxIn+0)
LDRB	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_TxQueue+0)
MOVT	R1, #hi_addr(_TxQueue+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; msg end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R2, R1, #1
UXTB	R2, R2
STRB	R2, [R3, #0]
;UART6.c,299 :: 		if (TxIn > (txqsize-1))   // Adjust FIFO in pointer
MOVW	R1, #1023
CMP	R2, R1
IT	LE
BLE	L_UART6_PutQueue46
;UART6.c,300 :: 		TxIn = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_TxIn+0)
MOVT	R1, #hi_addr(_TxIn+0)
STRB	R2, [R1, #0]
L_UART6_PutQueue46:
;UART6.c,301 :: 		}
L_end_UART6_PutQueue:
BX	LR
; end of _UART6_PutQueue
_UART6_SendMsg:
;UART6.c,305 :: 		void UART6_SendMsg(char *s) {
; s start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; s end address is: 0 (R0)
; s start address is: 0 (R0)
;UART6.c,306 :: 		XmtBuf = s;               // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_XmtBuf+0)
MOVT	R1, #hi_addr(_XmtBuf+0)
STR	R0, [R1, #0]
; s end address is: 0 (R0)
;UART6.c,307 :: 		XmtBufPtr = 0;            // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_XmtBufPtr+0)
MOVT	R1, #hi_addr(_XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART6.c,308 :: 		UART6_StartTx();          // Turn on the transmitter
BL	_UART6_StartTx+0
;UART6.c,309 :: 		}
L_end_UART6_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SendMsg
_UART6_CheckQueue:
;UART6.c,314 :: 		void UART6_CheckQueue(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,315 :: 		if (TXEIE_USART6_CR1_bit == 0) {   // Don't try to start transmitter if already transmitting
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_UART6_CheckQueue47
;UART6.c,316 :: 		if (TxIn != TxOut) {                 // If pointers are not the same
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART6_CheckQueue48
;UART6.c,317 :: 		UART6_SendMsg(TxQueue[TxOut++]); // Hand off the message pointer and increment counter
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_TxQueue+0)
MOVT	R0, #hi_addr(_TxQueue+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
BL	_UART6_SendMsg+0
MOVW	R2, #lo_addr(_TxOut+0)
MOVT	R2, #hi_addr(_TxOut+0)
LDRB	R0, [R2, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,318 :: 		if (TxOut > (txqsize-1))         // Check for wrap
MOVW	R0, #1023
CMP	R1, R0
IT	LE
BLE	L_UART6_CheckQueue49
;UART6.c,319 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
L_UART6_CheckQueue49:
;UART6.c,320 :: 		}
L_UART6_CheckQueue48:
;UART6.c,321 :: 		}
L_UART6_CheckQueue47:
;UART6.c,322 :: 		}
L_end_UART6_CheckQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_CheckQueue
